diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/regular-wifi-mac.cc ns-3.31/src/wifi/model/regular-wifi-mac.cc
--- ns-3.30.1/src/wifi/model/regular-wifi-mac.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/regular-wifi-mac.cc	2020-06-27 17:38:30.000000000 -0700
@@ -704,19 +704,6 @@
 }
 
 void
-RegularWifiMac::SetCtsTimeout (Time ctsTimeout)
-{
-  NS_LOG_FUNCTION (this << ctsTimeout);
-  m_low->SetCtsTimeout (ctsTimeout);
-}
-
-Time
-RegularWifiMac::GetCtsTimeout (void) const
-{
-  return m_low->GetCtsTimeout ();
-}
-
-void
 RegularWifiMac::SetBasicBlockAckTimeout (Time blockAckTimeout)
 {
   NS_LOG_FUNCTION (this << blockAckTimeout);
@@ -832,7 +819,7 @@
 }
 
 void
-RegularWifiMac::Enqueue (Ptr<const Packet> packet,
+RegularWifiMac::Enqueue (Ptr<Packet> packet,
                          Mac48Address to, Mac48Address from)
 {
   //We expect RegularWifiMac subclasses which do support forwarding (e.g.,
@@ -850,17 +837,19 @@
 }
 
 void
-RegularWifiMac::ForwardUp (Ptr<Packet> packet, Mac48Address from, Mac48Address to)
+RegularWifiMac::ForwardUp (Ptr<const Packet> packet, Mac48Address from, Mac48Address to)
 {
   NS_LOG_FUNCTION (this << packet << from << to);
   m_forwardUp (packet, from, to);
 }
 
 void
-RegularWifiMac::Receive (Ptr<Packet> packet, const WifiMacHeader *hdr)
+RegularWifiMac::Receive (Ptr<WifiMacQueueItem> mpdu)
 {
-  NS_LOG_FUNCTION (this << packet << hdr);
+  NS_LOG_FUNCTION (this << *mpdu);
 
+  const WifiMacHeader* hdr = &mpdu->GetHeader ();
+  Ptr<Packet> packet = mpdu->GetPacket ()->Copy ();
   Mac48Address to = hdr->GetAddr1 ();
   Mac48Address from = hdr->GetAddr2 ();
 
@@ -955,15 +944,13 @@
 }
 
 void
-RegularWifiMac::DeaggregateAmsduAndForward (Ptr<Packet> aggregatedPacket, const WifiMacHeader *hdr)
+RegularWifiMac::DeaggregateAmsduAndForward (Ptr<WifiMacQueueItem> mpdu)
 {
-  NS_LOG_FUNCTION (this << aggregatedPacket << hdr);
-  MsduAggregator::DeaggregatedMsdus packets = MsduAggregator::Deaggregate (aggregatedPacket);
-  for (MsduAggregator::DeaggregatedMsdusCI i = packets.begin ();
-       i != packets.end (); ++i)
+  NS_LOG_FUNCTION (this << *mpdu);
+  for (auto& msduPair : *PeekPointer (mpdu))
     {
-      ForwardUp ((*i).first, (*i).second.GetSourceAddr (),
-                 (*i).second.GetDestinationAddr ());
+      ForwardUp (msduPair.first, msduPair.second.GetSourceAddr (),
+                 msduPair.second.GetDestinationAddr ());
     }
 }
 
@@ -976,7 +963,7 @@
   hdr.SetType (WIFI_MAC_MGT_ACTION);
   hdr.SetAddr1 (originator);
   hdr.SetAddr2 (GetAddress ());
-  hdr.SetAddr3 (GetAddress ());
+  hdr.SetAddr3 (GetBssid ());
   hdr.SetDsNotFrom ();
   hdr.SetDsNotTo ();
 
@@ -1151,7 +1138,7 @@
                    MakeUintegerAccessor (&RegularWifiMac::SetBkBlockAckThreshold),
                    MakeUintegerChecker<uint8_t> (0, 64))
     .AddAttribute ("VO_BlockAckInactivityTimeout",
-                   "Represents max time (blocks of 1024 micro seconds) allowed for block ack"
+                   "Represents max time (blocks of 1024 microseconds) allowed for block ack"
                    "inactivity for AC_VO. If this value isn't equal to 0 a timer start after that a"
                    "block ack setup is completed and will be reset every time that a block ack"
                    "frame is received. If this value is 0, block ack inactivity timeout won't be used.",
@@ -1159,7 +1146,7 @@
                    MakeUintegerAccessor (&RegularWifiMac::SetVoBlockAckInactivityTimeout),
                    MakeUintegerChecker<uint16_t> ())
     .AddAttribute ("VI_BlockAckInactivityTimeout",
-                   "Represents max time (blocks of 1024 micro seconds) allowed for block ack"
+                   "Represents max time (blocks of 1024 microseconds) allowed for block ack"
                    "inactivity for AC_VI. If this value isn't equal to 0 a timer start after that a"
                    "block ack setup is completed and will be reset every time that a block ack"
                    "frame is received. If this value is 0, block ack inactivity timeout won't be used.",
@@ -1167,7 +1154,7 @@
                    MakeUintegerAccessor (&RegularWifiMac::SetViBlockAckInactivityTimeout),
                    MakeUintegerChecker<uint16_t> ())
     .AddAttribute ("BE_BlockAckInactivityTimeout",
-                   "Represents max time (blocks of 1024 micro seconds) allowed for block ack"
+                   "Represents max time (blocks of 1024 microseconds) allowed for block ack"
                    "inactivity for AC_BE. If this value isn't equal to 0 a timer start after that a"
                    "block ack setup is completed and will be reset every time that a block ack"
                    "frame is received. If this value is 0, block ack inactivity timeout won't be used.",
@@ -1175,7 +1162,7 @@
                    MakeUintegerAccessor (&RegularWifiMac::SetBeBlockAckInactivityTimeout),
                    MakeUintegerChecker<uint16_t> ())
     .AddAttribute ("BK_BlockAckInactivityTimeout",
-                   "Represents max time (blocks of 1024 micro seconds) allowed for block ack"
+                   "Represents max time (blocks of 1024 microseconds) allowed for block ack"
                    "inactivity for AC_BK. If this value isn't equal to 0 a timer start after that a"
                    "block ack setup is completed and will be reset every time that a block ack"
                    "frame is received. If this value is 0, block ack inactivity timeout won't be used.",
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/regular-wifi-mac.h ns-3.31/src/wifi/model/regular-wifi-mac.h
--- ns-3.30.1/src/wifi/model/regular-wifi-mac.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/regular-wifi-mac.h	2020-06-27 17:38:30.000000000 -0700
@@ -53,63 +53,58 @@
   RegularWifiMac ();
   virtual ~RegularWifiMac ();
 
-  /**
-   * \param slotTime the slot duration
-   */
+  // Implementations of pure virtual methods.
   void SetSlot (Time slotTime);
-  /**
-   * \param sifs the sifs duration
-   */
   void SetSifs (Time sifs);
-  /**
-   * \param eifsNoDifs the duration of an EIFS minus DIFS.
-   *
-   * This value is used to calculate the EIFS depending
-   * on AIFSN.
-   */
   void SetEifsNoDifs (Time eifsNoDifs);
-  /**
-   * \param pifs the pifs duration.
-   */
   void SetPifs (Time pifs);
-  /**
-   * \param rifs the rifs duration.
-   */
   void SetRifs (Time rifs);
-  /**
-   * \param ctsTimeout the duration of a CTS timeout.
-   */
-  void SetCtsTimeout (Time ctsTimeout);
-  /**
-   * \param ackTimeout the duration of an ACK timeout.
-   */
   void SetAckTimeout (Time ackTimeout);
-
+  void SetShortSlotTimeSupported (bool enable);
+  void SetSsid (Ssid ssid);
+  void SetAddress (Mac48Address address);
+  void SetPromisc (void);
   Time GetRifs (void) const;
-  /**
-   * \return the current PIFS duration.
-   */
   Time GetPifs (void) const;
-  /**
-   * \return the current SIFS duration.
-   */
   Time GetSifs (void) const;
-  /**
-   * \return the current slot duration.
-   */
   Time GetSlot (void) const;
-  /**
-   * \return the current EIFS minus DIFS duration
-   */
   Time GetEifsNoDifs (void) const;
+  Time GetAckTimeout (void) const;
+  bool GetShortSlotTimeSupported (void) const;
+  Ssid GetSsid (void) const;
+  Mac48Address GetAddress (void) const;
+  Mac48Address GetBssid (void) const;
+  virtual void Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from);
+  virtual bool SupportsSendFrom (void) const;
+  virtual void SetWifiPhy (const Ptr<WifiPhy> phy);
+  Ptr<WifiPhy> GetWifiPhy (void) const;
+  void ResetWifiPhy (void);
+  virtual void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> stationManager);
+
   /**
-   * \return the current CTS timeout duration.
+   * This type defines the callback of a higher layer that a
+   * WifiMac(-derived) object invokes to pass a packet up the stack.
+   *
+   * \param packet the packet that has been received.
+   * \param from the MAC address of the device that sent the packet.
+   * \param to the MAC address of the device that the packet is destined for.
    */
-  Time GetCtsTimeout (void) const;
-  /**
-   * \return the current ACK timeout duration.
+  typedef Callback<void, Ptr<const Packet>, Mac48Address, Mac48Address> ForwardUpCallback;
+
+  void SetForwardUpCallback (ForwardUpCallback upCallback);
+  void SetLinkUpCallback (Callback<void> linkUp);
+  void SetLinkDownCallback (Callback<void> linkDown);
+
+  /* Next functions are not pure virtual so non-QoS WifiMacs are not
+   * forced to implement them.
    */
-  Time GetAckTimeout (void) const;
+  void SetBasicBlockAckTimeout (Time blockAckTimeout);
+  Time GetBasicBlockAckTimeout (void) const;
+  void SetCompressedBlockAckTimeout (Time blockAckTimeout);
+  Time GetCompressedBlockAckTimeout (void) const;
+
+  // Should be implemented by child classes
+  virtual void Enqueue (Ptr<Packet> packet, Mac48Address to) = 0;
 
   /**
    * Enable or disable CTS-to-self feature.
@@ -118,21 +113,6 @@
    *               false otherwise
    */
   void SetCtsToSelfSupported (bool enable);
-
-  /**
-   * Enable or disable short slot time feature.
-   *
-   * \param enable true if short slot time is to be supported,
-   *               false otherwise
-   */
-  void SetShortSlotTimeSupported (bool enable);
-  /**
-   * \return whether the device supports short slot time capability.
-   *
-   * \return true if short slot time is supported,
-   *         false otherwise.
-   */
-  bool GetShortSlotTimeSupported (void) const;
   /**
    * Enable or disable RIFS feature.
    *
@@ -150,79 +130,11 @@
    */
   bool GetRifsSupported (void) const;
   /**
-   * \return the MAC address associated to this MAC layer.
-   */
-  Mac48Address GetAddress (void) const;
-  /**
-   * \return the ssid which this MAC layer is going to try to stay in.
-   */
-  Ssid GetSsid (void) const;
-  /**
-   * \param address the current address of this MAC layer.
-   */
-  void SetAddress (Mac48Address address);
-  /**
-   * \param ssid the current ssid of this MAC layer.
-   */
-  void SetSsid (Ssid ssid);
-  /**
    * \param bssid the BSSID of the network that this device belongs to.
    */
   void SetBssid (Mac48Address bssid);
-  /**
-   * \return the bssid of the network this device belongs to.
-   */
-  Mac48Address GetBssid (void) const;
-  /**
-   * \brief Sets the interface in promiscuous mode.
-   *
-   * Enables promiscuous mode on the interface. Note that any further
-   * filtering on the incoming frame path may affect the overall
-   * behavior.
-   */
-  void SetPromisc (void);
 
   /**
-   * \param packet the packet to send.
-   * \param to the address to which the packet should be sent.
-   * \param from the address from which the packet should be sent.
-   *
-   * The packet should be enqueued in a tx queue, and should be
-   * dequeued as soon as the channel access function determines that
-   * access is granted to this MAC.  The extra parameter "from" allows
-   * this device to operate in a bridged mode, forwarding received
-   * frames without altering the source address.
-   */
-  virtual void Enqueue (Ptr<const Packet> packet, Mac48Address to, Mac48Address from);
-
-  virtual bool SupportsSendFrom (void) const;
-
-  /**
-   * \param packet the packet to send.
-   * \param to the address to which the packet should be sent.
-   *
-   * The packet should be enqueued in a tx queue, and should be
-   * dequeued as soon as the channel access function determines that
-   * access is granted to this MAC.
-   */
-  virtual void Enqueue (Ptr<const Packet> packet, Mac48Address to) = 0;
-  /**
-   * \param phy the physical layer attached to this MAC.
-   */
-  virtual void SetWifiPhy (const Ptr<WifiPhy> phy);
-  /**
-   * \return the physical layer attached to this MAC.
-   */
-  Ptr<WifiPhy> GetWifiPhy (void) const;
-  /**
-   * removes attached WifiPhy device from this MAC.
-   */
-  void ResetWifiPhy (void);
-  /**
-   * \param stationManager the station manager attached to this MAC.
-   */
-  virtual void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> stationManager);
-  /**
    * \return the station manager attached to this MAC.
    */
   Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager (void) const;
@@ -251,47 +163,15 @@
    */
   HeCapabilities GetHeCapabilities (void) const;
 
-  /**
-   * This type defines the callback of a higher layer that a
-   * WifiMac(-derived) object invokes to pass a packet up the stack.
-   *
-   * \param packet the packet that has been received.
-   * \param from the MAC address of the device that sent the packet.
-   * \param to the MAC address of the device that the packet is destined for.
-   */
-  typedef Callback<void, Ptr<Packet>, Mac48Address, Mac48Address> ForwardUpCallback;
-  /**
-   * \param upCallback the callback to invoke when a packet must be
-   * forwarded up the stack.
-   */
-  void SetForwardUpCallback (ForwardUpCallback upCallback);
-  /**
-   * \param linkUp the callback to invoke when the link becomes up.
-   */
-  void SetLinkUpCallback (Callback<void> linkUp);
-  /**
-   * \param linkDown the callback to invoke when the link becomes down.
-   */
-  void SetLinkDownCallback (Callback<void> linkDown);
-
-  /* Next functions are not pure virtual so non Qos WifiMacs are not
-   * forced to implement them.
-   */
-  void SetBasicBlockAckTimeout (Time blockAckTimeout);
-  Time GetBasicBlockAckTimeout (void) const;
-  void SetCompressedBlockAckTimeout (Time blockAckTimeout);
-  Time GetCompressedBlockAckTimeout (void) const;
-
-
 protected:
   virtual void DoInitialize ();
   virtual void DoDispose ();
 
-  Ptr<MacRxMiddle> m_rxMiddle;  //!< RX middle (de-fragmentation etc.)
+  Ptr<MacRxMiddle> m_rxMiddle;  //!< RX middle (defragmentation etc.)
   Ptr<MacTxMiddle> m_txMiddle;  //!< TX middle (aggregation etc.)
-  Ptr<MacLow> m_low;        //!< MacLow (RTS, CTS, DATA, ACK etc.)
+  Ptr<MacLow> m_low;            //!< MacLow (RTS, CTS, Data, Ack etc.)
   Ptr<ChannelAccessManager> m_channelAccessManager; //!< channel access manager
-  Ptr<WifiPhy> m_phy;       //!< Wifi PHY
+  Ptr<WifiPhy> m_phy;           //!< Wifi PHY
 
   Ptr<WifiRemoteStationManager> m_stationManager; //!< Remote station manager (rate control, RTS/CTS/fragmentation thresholds etc.)
 
@@ -346,10 +226,10 @@
   Ptr<QosTxop> GetBKQueue (void) const;
 
   /**
-   * \param standard the phy standard to be used
+   * \param standard the PHY standard to be used
    *
    * This method is called by ns3::WifiMac::ConfigureStandard to
-   * complete the configuration process for a requested phy standard.
+   * complete the configuration process for a requested PHY standard.
    *
    * This method may be overridden by a derived class (e.g., in order
    * to apply DCF or EDCA parameters specific to the usage model it is
@@ -360,8 +240,8 @@
   void FinishConfigureStandard (WifiPhyStandard standard);
 
   /**
-   * \param cwMin the minimum congestion window size
-   * \param cwMax the maximum congestion window size
+   * \param cwMin the minimum contention window size
+   * \param cwMax the maximum contention window size
    *
    * This method is called to set the minimum and the maximum
    * contention window size.
@@ -389,20 +269,19 @@
    * classes so that they can perform their data handling before
    * invoking the base version.
    *
-   * \param packet the packet that has been received.
-   * \param hdr a pointer to the MAC header of the received frame.
+   * \param mpdu the MPDU that has been received.
    */
-  virtual void Receive (Ptr<Packet> packet, const WifiMacHeader *hdr);
+  virtual void Receive (Ptr<WifiMacQueueItem> mpdu);
   /**
    * The packet we sent was successfully received by the receiver
-   * (i.e. we received an ACK from the receiver).
+   * (i.e. we received an Ack from the receiver).
    *
    * \param hdr the header of the packet that we successfully sent
    */
   virtual void TxOk (const WifiMacHeader &hdr);
   /**
    * The packet we sent was successfully received by the receiver
-   * (i.e. we did not receive an ACK from the receiver).
+   * (i.e. we did not receive an Ack from the receiver).
    *
    * \param hdr the header of the packet that we failed to sent
    */
@@ -415,17 +294,15 @@
    * \param from the address of the source
    * \param to the address of the destination
    */
-  void ForwardUp (Ptr<Packet> packet, Mac48Address from, Mac48Address to);
+  void ForwardUp (Ptr<const Packet> packet, Mac48Address from, Mac48Address to);
 
   /**
    * This method can be called to de-aggregate an A-MSDU and forward
    * the constituent packets up the stack.
    *
-   * \param aggregatedPacket the Packet containing the A-MSDU.
-   * \param hdr a pointer to the MAC header for \c aggregatedPacket.
+   * \param mpdu the MPDU containing the A-MSDU.
    */
-  virtual void DeaggregateAmsduAndForward (Ptr<Packet> aggregatedPacket,
-                                           const WifiMacHeader *hdr);
+  virtual void DeaggregateAmsduAndForward (Ptr<WifiMacQueueItem> mpdu);
 
   /**
    * This method can be called to accept a received ADDBA Request. An
@@ -535,27 +412,27 @@
   void SetupEdcaQueue (AcIndex ac);
 
   /**
-   * Set the Block ACK threshold for AC_VO.
+   * Set the block ack threshold for AC_VO.
    *
-   * \param threshold the Block ACK threshold for AC_VO.
+   * \param threshold the block ack threshold for AC_VO.
    */
   void SetVoBlockAckThreshold (uint8_t threshold);
   /**
-   * Set the Block ACK threshold for AC_VI.
+   * Set the block ack threshold for AC_VI.
    *
-   * \param threshold the Block ACK threshold for AC_VI.
+   * \param threshold the block ack threshold for AC_VI.
    */
   void SetViBlockAckThreshold (uint8_t threshold);
   /**
-   * Set the Block ACK threshold for AC_BE.
+   * Set the block ack threshold for AC_BE.
    *
-   * \param threshold the Block ACK threshold for AC_BE.
+   * \param threshold the block ack threshold for AC_BE.
    */
   void SetBeBlockAckThreshold (uint8_t threshold);
   /**
-   * Set the Block ACK threshold for AC_BK.
+   * Set the block ack threshold for AC_BK.
    *
-   * \param threshold the Block ACK threshold for AC_BK.
+   * \param threshold the block ack threshold for AC_BK.
    */
   void SetBkBlockAckThreshold (uint8_t threshold);
 
@@ -614,15 +491,15 @@
   /// Disable aggregation function
   void DisableAggregation (void);
 
-  uint16_t m_voMaxAmsduSize; ///< maximum A-MSDU size for AC_VO
-  uint16_t m_viMaxAmsduSize; ///< maximum A-MSDU size for AC_VI
-  uint16_t m_beMaxAmsduSize; ///< maximum A-MSDU size for AC_BE
-  uint16_t m_bkMaxAmsduSize; ///< maximum A-MSDU size for AC_BK
-
-  uint32_t m_voMaxAmpduSize; ///< maximum A-MPDU size for AC_VO
-  uint32_t m_viMaxAmpduSize; ///< maximum A-MPDU size for AC_VI
-  uint32_t m_beMaxAmpduSize; ///< maximum A-MPDU size for AC_BE
-  uint32_t m_bkMaxAmpduSize; ///< maximum A-MPDU size for AC_BK
+  uint16_t m_voMaxAmsduSize; ///< maximum A-MSDU size for AC_VO (in bytes)
+  uint16_t m_viMaxAmsduSize; ///< maximum A-MSDU size for AC_VI (in bytes)
+  uint16_t m_beMaxAmsduSize; ///< maximum A-MSDU size for AC_BE (in bytes)
+  uint16_t m_bkMaxAmsduSize; ///< maximum A-MSDU size for AC_BK (in bytes)
+
+  uint32_t m_voMaxAmpduSize; ///< maximum A-MPDU size for AC_VO (in bytes)
+  uint32_t m_viMaxAmpduSize; ///< maximum A-MPDU size for AC_VI (in bytes)
+  uint32_t m_beMaxAmpduSize; ///< maximum A-MPDU size for AC_BE (in bytes)
+  uint32_t m_bkMaxAmpduSize; ///< maximum A-MPDU size for AC_BK (in bytes)
 
   TracedCallback<const WifiMacHeader &> m_txOkCallback; ///< transmit OK callback
   TracedCallback<const WifiMacHeader &> m_txErrCallback; ///< transmit error callback
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/rraa-wifi-manager.cc ns-3.31/src/wifi/model/rraa-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/rraa-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/rraa-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -47,8 +47,8 @@
   bool m_adaptiveRtsOn;          //!< Check if Adaptive RTS mechanism is on.
   bool m_lastFrameFail;          //!< Flag if the last frame sent has failed.
   bool m_initialized;            //!< For initializing variables.
-  uint8_t m_nRate;              //!< Number of supported rates.
-  uint8_t m_rateIndex;          //!< Current rate index.
+  uint8_t m_nRate;               //!< Number of supported rates.
+  uint8_t m_rateIndex;           //!< Current rate index.
 
   RraaThresholdsTable m_thresholds; //!< RRAA thresholds for this station.
 };
@@ -68,17 +68,17 @@
                    MakeBooleanAccessor (&RraaWifiManager::m_basic),
                    MakeBooleanChecker ())
     .AddAttribute ("Timeout",
-                   "Timeout for the RRAA BASIC loss estimation block (s)",
+                   "Timeout for the RRAA BASIC loss estimation block",
                    TimeValue (Seconds (0.05)),
                    MakeTimeAccessor (&RraaWifiManager::m_timeout),
                    MakeTimeChecker ())
     .AddAttribute ("FrameLength",
-                   "The data frame length (in bytes) used for calculating mode TxTime.",
+                   "The Data frame length (in bytes) used for calculating mode TxTime.",
                    UintegerValue (1420),
                    MakeUintegerAccessor (&RraaWifiManager::m_frameLength),
                    MakeUintegerChecker <uint32_t> ())
     .AddAttribute ("AckFrameLength",
-                   "The ACK frame length (in bytes) used for calculating mode TxTime.",
+                   "The Ack frame length (in bytes) used for calculating mode TxTime.",
                    UintegerValue (14),
                    MakeUintegerAccessor (&RraaWifiManager::m_ackLength),
                    MakeUintegerChecker <uint32_t> ())
@@ -128,7 +128,7 @@
       WifiTxVector txVector;
       txVector.SetMode (mode);
       txVector.SetPreambleType (WIFI_PREAMBLE_LONG);
-      /* Calculate the TX Time of the data and the corresponding ACK*/
+      /* Calculate the TX Time of the Data and the corresponding Ack */
       Time dataTxTime = phy->CalculateTxDuration (m_frameLength, txVector, phy->GetFrequency ());
       Time ackTxTime = phy->CalculateTxDuration (m_ackLength, txVector, phy->GetFrequency ());
       NS_LOG_DEBUG ("Calculating TX times: Mode= " << mode << " DataTxTime= " << dataTxTime << " AckTxTime= " << ackTxTime);
@@ -300,7 +300,7 @@
 RraaWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  RraaWifiRemoteStation *station = (RraaWifiRemoteStation *) st;
+  RraaWifiRemoteStation *station = static_cast<RraaWifiRemoteStation*> (st);
   station->m_lastFrameFail = true;
   CheckTimeout (station);
   station->m_counter--;
@@ -323,11 +323,11 @@
 }
 
 void
-RraaWifiManager::DoReportDataOk (WifiRemoteStation *st,
-                                 double ackSnr, WifiMode ackMode, double dataSnr)
+RraaWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                 double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  RraaWifiRemoteStation *station = (RraaWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  RraaWifiRemoteStation *station = static_cast<RraaWifiRemoteStation*> (st);
   station->m_lastFrameFail = false;
   CheckTimeout (station);
   station->m_counter--;
@@ -350,11 +350,10 @@
 RraaWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  RraaWifiRemoteStation *station = (RraaWifiRemoteStation *) st;
+  RraaWifiRemoteStation *station = static_cast<RraaWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   CheckInit (station);
@@ -371,11 +370,10 @@
 RraaWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  RraaWifiRemoteStation *station = (RraaWifiRemoteStation *) st;
+  RraaWifiRemoteStation *station = static_cast<RraaWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiTxVector rtsTxVector;
@@ -394,10 +392,10 @@
 
 bool
 RraaWifiManager::DoNeedRts (WifiRemoteStation *st,
-                            Ptr<const Packet> packet, bool normally)
+                            uint32_t size, bool normally)
 {
-  NS_LOG_FUNCTION (this << st << packet << normally);
-  RraaWifiRemoteStation *station = (RraaWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << size << normally);
+  RraaWifiRemoteStation *station = static_cast<RraaWifiRemoteStation*> (st);
   CheckInit (station);
   if (m_basic)
     {
@@ -467,17 +465,11 @@
 }
 
 WifiRraaThresholds
-RraaWifiManager::GetThresholds (RraaWifiRemoteStation *station, uint8_t rate) const
+RraaWifiManager::GetThresholds (RraaWifiRemoteStation *station, uint8_t index) const
 {
-  NS_LOG_FUNCTION (this << station << +rate);
-  WifiMode mode = GetSupported (station, rate);
+  NS_LOG_FUNCTION (this << station << +index);
+  WifiMode mode = GetSupported (station, index);
   return GetThresholds (station, mode);
 }
 
-bool
-RraaWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/rraa-wifi-manager.h ns-3.31/src/wifi/model/rraa-wifi-manager.h
--- ns-3.30.1/src/wifi/model/rraa-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/rraa-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -51,9 +51,9 @@
  * by "Starsky H. Y. Wong", "Hao Yang", "Songwu Lu", and,
  * "Vaduvur Bharghavan" published in Mobicom 06.
  *
- * This RAA does not support HT, VHT nor HE modes and will error
+ * This RAA does not support HT modes and will error
  * exit if the user tries to configure this RAA with a Wi-Fi MAC
- * that has VhtSupported, HtSupported or HeSupported set.
+ * that supports 802.11n or higher.
  */
 class RraaWifiManager : public WifiRemoteStationManager
 {
@@ -82,15 +82,14 @@
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
   bool DoNeedRts (WifiRemoteStation *st,
-                  Ptr<const Packet> packet, bool normally);
-  bool IsLowLatency (void) const;
+                  uint32_t size, bool normally);
 
   /**
    * Check for initializations.
@@ -101,7 +100,7 @@
    * Return the index for the maximum transmission rate for
    * the given station.
    *
-   * \param station
+   * \param station the remote station
    *
    * \return the index for the maximum transmission rate
    */
@@ -109,64 +108,64 @@
   /**
    * Check if the counter should be reset.
    *
-   * \param station
+   * \param station the remote station
    */
   void CheckTimeout (RraaWifiRemoteStation *station);
   /**
    * Find an appropriate rate for the given station, using
    * a basic algorithm.
    *
-   * \param station
+   * \param station the remote station
    */
   void RunBasicAlgorithm (RraaWifiRemoteStation *station);
   /**
    * Activate the use of RTS for the given station if the conditions are met.
    *
-   * \param station
+   * \param station the remote station
    */
   void ARts (RraaWifiRemoteStation *station);
   /**
    * Reset the counters of the given station.
    *
-   * \param station
+   * \param station the remote station
    */
   void ResetCountersBasic (RraaWifiRemoteStation *station);
   /**
    * Initialize the thresholds internal list for the given station.
    *
-   * \param station
+   * \param station the remote station
    */
   void InitThresholds (RraaWifiRemoteStation *station);
   /**
    * Get the thresholds for the given station and mode.
    *
-   * \param station
-   * \param mode
+   * \param station the remote station
+   * \param mode the WifiMode
    *
-   * \return threshold
+   * \return the RRAA thresholds
    */
   WifiRraaThresholds GetThresholds (RraaWifiRemoteStation *station, WifiMode mode) const;
   /**
    * Get the thresholds for the given station and mode index.
    *
-   * \param station
-   * \param rate
+   * \param station the remote station
+   * \param index the mode index in the supported rates
    *
-   * \return threshold
+   * \return the RRAA thresholds
    */
-  WifiRraaThresholds GetThresholds (RraaWifiRemoteStation *station, uint8_t rate) const;
+  WifiRraaThresholds GetThresholds (RraaWifiRemoteStation *station, uint8_t index) const;
   /**
    * Get the estimated TxTime of a packet with a given mode.
    *
-   * \param mode
+   * \param mode the WifiMode
    *
-   * \return time
+   * \return the estimated TX time
    */
   Time GetCalcTxTime (WifiMode mode) const;
   /**
    * Add transmission time for the given mode to an internal list.
    *
-   * \param mode Wi-Fi mode
+   * \param mode the WifiMode
    * \param t transmission time
    */
   void AddCalcTxTime (WifiMode mode, Time t);
